;----------------------------------------------------------------------------
;    MODULE NAME:   CRC16REX.X
;
;        $Author:   Dennis_Bareis  $
;      $Revision:   1.1  $
;          $Date:   31 Jan 1999 17:40:48  $
;       $Logfile:   E:/DB/PVCS.IT/OS2/REXXHDR/CRC16REX.X_V  $
;         SOURCE:   http://www.labyrinth.net.au/~dbareis/index.htm (db0@anz.com)
;
;    DESCRIPTION:   Example program for "CRC16REX.XH".
;
;                   Compile with "ppwizard CRC16REX.X /rexx"
;----------------------------------------------------------------------------

/*
 * $Header:   E:/DB/PVCS.IT/OS2/REXXHDR/CRC16REX.X_V   1.1   31 Jan 1999 17:40:48   Dennis_Bareis  $
 */


/*--- Include REXX HEADER FOR CRC16 SUPPORT ---------------------------------*/
#include "CRC16REX.XH"

/*--- Expect the name of a file ---------------------------------------------*/
CrcFile = strip(arg(1));
if CrcFile = '' then
do
   say "This example program requires the name of a file (don't choose huge one please!)";
   exit(GetLineNumber());
end;
if stream(CrcFile, 'c', 'query exists') = '' then
do
   say 'The file you chose does not exist';
   exit(GetLineNumber());
end;

/*--- Read the data from the file -------------------------------------------*/
LimitTo     = 999999;
CloseRc     = stream(CrcFile, 'c', 'close');
FromFile    = charin(CrcFile,, LimitTo);
FromFileLng = length(FromFile);
CloseRc     = stream(CrcFile, 'c', 'close');
say 'Read ' || FromFileLng || ' bytes from file';
if FromFileLng = LimitTo then
do
   say 'Choose a smaller file will ya!';
   exit(GetLineNumber());
end;

/*--- Say stuff -------------------------------------------------------------*/
say ''
say "I'm about to calculate the CRC, on a 100Meg Pentium we can do about"
say '5,000 bytes per second, assuming similar performance on your machine this'
say 'will take approx ' || FromFileLng/5000 || ' seconds.';
say ''

/*--- Initialize CRC --------------------------------------------------------*/
Dummy = time('Reset');
CRC16 = InitializeCrc16();

/*--- Now update CRC16, can do as many times as required to handle all memory ---*/
CRC16 = UpdateCRC16(CRC16, FromFile);

/*--- Complete CRC ----------------------------------------------------------*/
ElapsedTime = time('Elapsed');

/*--- Display CRC and Exit --------------------------------------------------*/
say 'CRC16   : ' || CRC16InDisplayableForm(CRC16);
say 'ELAPSED : ' || ElapsedTime || ' seconds';
say 'SPEED   : ' || FromFileLng/ElapsedTime || ' bytes per second';
Dummy = time('Reset');
exit(0);




/*===========================================================================*/
GetLineNumber:
/*===========================================================================*/
   return( SIGL );


